StartRecommendation
Starts a recommendation job that analyzes agent traces and generates optimization suggestions for system prompts or tool descriptions to improve agent performance.
Request Syntax
POST /recommendations HTTP/1.1
Content-type: application/json
{
"clientToken": "string",
"description": "string",
"name": "string",
"recommendationConfig": { ... },
"type": "string"
}
URI Request Parameters
The request does not use any URI parameters.
Request Body
The request accepts the following data in JSON format.
- clientToken
-
A unique, case-sensitive identifier to ensure that the API request completes no more than one time. If this token matches a previous request, the service ignores the request, but does not return an error.
Type: String
Length Constraints: Minimum length of 33. Maximum length of 256.
Pattern:
[a-zA-Z0-9](-*[a-zA-Z0-9]){0,256}Required: No
- description
-
The description of the recommendation.
Type: String
Length Constraints: Minimum length of 0. Maximum length of 4096.
Required: No
- name
-
The name of the recommendation. Must be unique within your account.
Type: String
Length Constraints: Minimum length of 0. Maximum length of 100.
Pattern:
[a-zA-Z][a-zA-Z0-9_-]{0,47}Required: Yes
- recommendationConfig
-
The configuration for the recommendation, including the input to optimize, agent traces to analyze, and evaluation settings.
Type: RecommendationConfig object
Note: This object is a Union. Only one member of this object can be specified or returned.
Required: Yes
- type
-
The type of recommendation to generate. Valid values are
SYSTEM_PROMPT_RECOMMENDATIONfor system prompt optimization orTOOL_DESCRIPTION_RECOMMENDATIONfor tool description optimization.Type: String
Valid Values:
SYSTEM_PROMPT_RECOMMENDATION | TOOL_DESCRIPTION_RECOMMENDATIONRequired: Yes
Response Syntax
HTTP/1.1 202
Content-type: application/json
{
"createdAt": "string",
"description": "string",
"name": "string",
"recommendationArn": "string",
"recommendationConfig": { ... },
"recommendationId": "string",
"status": "string",
"type": "string",
"updatedAt": "string"
}
Response Elements
If the action is successful, the service sends back an HTTP 202 response.
The following data is returned in JSON format by the service.
- createdAt
-
The timestamp when the recommendation was created.
Type: Timestamp
- description
-
The description of the recommendation.
Type: String
Length Constraints: Minimum length of 0. Maximum length of 4096.
- name
-
The name of the recommendation.
Type: String
Length Constraints: Minimum length of 0. Maximum length of 100.
Pattern:
[a-zA-Z][a-zA-Z0-9_-]{0,47} - recommendationArn
-
The Amazon Resource Name (ARN) of the created recommendation.
Type: String
Pattern:
arn:aws[a-zA-Z-]*:bedrock-agentcore:[a-z0-9-]+:[0-9]{12}:recommendation/[0-9a-zA-Z_-]{1,48}-[0-9A-Z]{10} - recommendationConfig
-
The configuration for the recommendation.
Type: RecommendationConfig object
Note: This object is a Union. Only one member of this object can be specified or returned.
- recommendationId
-
The unique identifier of the created recommendation.
Type: String
Pattern:
[0-9a-zA-Z_-]{1,48}-[0-9A-Z]{10} - status
-
The status of the recommendation.
Type: String
Valid Values:
PENDING | IN_PROGRESS | COMPLETED | FAILED | DELETING - type
-
The type of recommendation.
Type: String
Valid Values:
SYSTEM_PROMPT_RECOMMENDATION | TOOL_DESCRIPTION_RECOMMENDATION - updatedAt
-
The timestamp when the recommendation was last updated.
Type: Timestamp
Errors
For information about the errors that are common to all actions, see Common Error Types.
- AccessDeniedException
-
The exception that occurs when you do not have sufficient permissions to perform an action. Verify that your IAM policy includes the necessary permissions for the operation you are trying to perform.
HTTP Status Code: 403
- ConflictException
-
The exception that occurs when the request conflicts with the current state of the resource. This can happen when trying to modify a resource that is currently being modified by another request, or when trying to create a resource that already exists.
HTTP Status Code: 409
- InternalServerException
-
The exception that occurs when the service encounters an unexpected internal error. This is a temporary condition that will resolve itself with retries. We recommend implementing exponential backoff retry logic in your application.
HTTP Status Code: 500
- ServiceQuotaExceededException
-
The exception that occurs when the request would cause a service quota to be exceeded. Review your service quotas and either reduce your request rate or request a quota increase.
HTTP Status Code: 402
- ThrottlingException
-
The exception that occurs when the request was denied due to request throttling. This happens when you exceed the allowed request rate for an operation. Reduce the frequency of requests or implement exponential backoff retry logic in your application.
HTTP Status Code: 429
- ValidationException
-
The exception that occurs when the input fails to satisfy the constraints specified by the service. Check the error message for details about which input parameter is invalid and correct your request.
HTTP Status Code: 400
See Also
For more information about using this API in one of the language-specific AWS SDKs, see the following: